#include "Entity3d.h"

Entity3d::Entity3d(void)
{
	rendered_type = CUBE;

	xpos = ypos = 0.0f;
	width = length = height = 1.0f;
}

Entity3d::~Entity3d(void)
{
}

void Entity3d::Initialize(float x, float y, float w, float l, float h)
{
	xpos = x;
	ypos = y;
	width = ABS(w);
	length = ABS(l);
	height = ABS(h);
}


void Entity3d::Render()
{
	//position in correct location
	glPushMatrix();
	glScalef(width, length, height);
	glTranslatef(xpos/width, ypos/length, 0.5);

	switch(rendered_type)
	{
	case CUBE:
		glutSolidCube(1.0);
		break;
	}

	glPopMatrix();
}