#pragma once

#include "Entity3d.h"

#define MAX_ENTITIES 500
#define TEXTURE_COUNT 5

class Entity3dCollection
{
public:
	void AddEntity(Entity3d ent, int textureIndex = 0);
	void Clear();
	void Render(GLuint *textures);

	Entity3dCollection(void);
	~Entity3dCollection(void);
private:
	Entity3d m_entities[TEXTURE_COUNT][MAX_ENTITIES];
	int m_entitycount[TEXTURE_COUNT];
};
